<template>
  <GI18nCard
    v-bind="$attrs"
    :card="true"
    level="third"
    optional
    :wiki-entry="wikiEntry"
    @deleteElement="$emit('delete')"
  >
    <template #card-title-append>
      <v-spacer />
      <GIconBtn
        v-if="value && !value.name"
        i18n="dcc.common.richContentType.addName"
        icon="mdi-text-box-plus-outline"
        btn-class="mr-4"
        small-btn
        @click="addName"
      />
      <GIconBtn
        v-else
        i18n="dcc.common.richContentType.deleteName"
        icon="mdi-text-box-remove-outline"
        btn-class="mr-4"
        small-btn
        @click="deleteName"
      />
      <GIconBtn
        v-if="value && !value.content"
        i18n="dcc.common.richContentType.addContent"
        icon="mdi-text-box-plus"
        btn-class="mr-4"
        small-btn
        @click="addContent"
      />
      <GIconBtn
        v-else
        i18n="dcc.common.richContentType.deleteContent"
        icon="mdi-text-box-remove"
        btn-class="mr-4"
        small-btn
        @click="deleteContent"
      />
      <GIconBtn
        i18n="dcc.common.richContentType.addFile"
        icon="mdi-file"
        btn-class="mr-4"
        small-btn
        @click="$refs.upload.click()"
      />
      <GIconBtn
        i18n="dcc.common.richContentType.addFormula"
        icon="mdi-sigma"
        btn-class="mr-4"
        small-btn
        @click="addFormula"
      />
      <span class="mr-4">|</span>
    </template>
    <div>
      <div v-if="value && value.name" class="mt-4">
        <DccLocalizedTextBlock
          v-model="value.name"
          i18n="dcc.common.richContentType.name"
          validate="required"
        />
      </div>
      <!-- v-lazy: workaround for auto-grow issue -->
      <v-lazy v-if="value && value.content" class="mt-4">
        <DccLocalizedTextarea
          v-model="content"
          i18n="dcc.common.richContentType.content"
          validate="required"
          rich-content
        />
      </v-lazy>
      <GFileItem v-if="value && value.file" v-model="value.file" />
      <input
        ref="upload"
        class="d-none"
        type="file"
        aria-label="File upload"
        @change="onFileChange"
      />
      <GFormulaInput
        v-if="value && value.formula"
        ref="formula"
        v-model="value.formula"
        validate="required"
      />
      <v-alert
        v-if="!value.name && !value.content && !value.file && !value.formula"
        color="warning"
        class="mb-0 mt-4"
        icon="warning"
      >
        {{ $t("dcc.common.richContentType.empty") }}
      </v-alert>
    </div>
  </GI18nCard>
</template>

<script>
import {
  TextType,
  FormulaType,
  DCCXMLElement,
  ByteDataType,
} from "@d-ptb/dcc-js";
import GFormulaInput from "../../App/Form/gFormulaInput";
import GFileItem from "../../App/Form/gFileItem";
import DccLocalizedTextarea from "~/components/App/Form/XML/DccLocalizedTextarea";
import DccLocalizedTextBlock from "~/components/App/Form/XML/DccLocalizedTextBlock";
import gFormulaInput from "~/components/App/Form/gFormulaInput";
import GI18nCard from "~/components/App/Common/GI18nCard";
import GIconBtn from "@/components/App/Common/GIconBtn";
import { validatableMixin } from "@/components/Mixins/validatableMixin";

export default {
  name: "RichContent",
  components: {
    GIconBtn,
    GFormulaInput,
    DccLocalizedTextarea,
    DccLocalizedTextBlock,
    gFormulaInput,
    GI18nCard,
    GFileItem,
  },
  mixins: [validatableMixin],
  props: {
    value: Object,
    level: String,
    optional: Boolean,
    notInDialog: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "richContent",
    },
  },
  computed: {
    content: {
      get() {
        return this.value;
      },
      set(val) {
        this.$emit("input", val);
      },
    },
    customRules() {
      return [
        () =>
          !!(
            this.value.name ||
            this.value.content ||
            this.value.file ||
            this.value.formula
          ),
      ];
    },
  },
  watch: {
    value() {
      this.validate();
    },
  },
  methods: {
    addName() {
      this.$set(this.value, "name", new TextType({ content: [] }));
    },
    deleteName() {
      if (!confirm(this.$t("dcc.common.richContentType.confirmRemoveName"))) {
        return;
      }
      this.$delete(this.value, "name");
    },
    addContent() {
      this.$set(this.value, "content", []);
    },
    deleteContent() {
      if (
        !confirm(this.$t("dcc.common.richContentType.confirmRemoveContent"))
      ) {
        return;
      }
      this.$delete(this.value, "content");
    },
    addFormula() {
      this.value.formula
        ? this.value.formula.push(
            new FormulaType({ latex: new DCCXMLElement() })
          )
        : this.$set(this.value, "formula", [
            new FormulaType({ latex: new DCCXMLElement() }),
          ]);
      // scroll to new formula
      this.$nextTick(() => {
        if (this.notInDialog) {
          this.$vuetify.goTo(
            this.$refs.formula.$refs.formula[
              this.$refs.formula.$refs.formula.length - 1
            ]
          );
        } else {
          const formulas = document.getElementsByClassName("formula");
          formulas[formulas.length - 1].scrollIntoView({ behavior: "smooth" });
        }
      });
    },
    loadFile(file) {
      const reader = new FileReader();
      reader.onload = (res) => {
        const base64data = res.target.result;
        const index = base64data.indexOf(",") + 1;
        const dataBase64Substring = base64data.substring(index);
        this.processData({
          fileName: file.name,
          mimeType: file.type,
          dataBase64: dataBase64Substring,
        });
      };
      reader.readAsDataURL(file);
    },
    onFileChange(e) {
      if (e.target.files.length === 1) {
        const file = e.target.files[0];
        this.loadFile(file);
        this.$refs.upload.value = "";
      }
    },
    processData(data) {
      const newFile = new ByteDataType();
      newFile.fileName._text = data.fileName;
      newFile.mimeType._text = data.mimeType;
      newFile.dataBase64._text = data.dataBase64;
      this.value.file
        ? this.value.file.push(newFile)
        : this.$set(this.value, "file", [newFile]);
    },
  },
};
</script>
